int x , y , seed = - 1 ;
char * p , buf [ 17 ] [ 40 ] ;

void pixel ( int x , int y , int color ) `0 image.pixel`

void putpixel ( int x , int y , int color ) {
   pixel ( 4 * x + 1 , 4 * y + 1 , color ) ;
   pixel ( 4 * x + 1 , 4 * y + 2 , color ) ;
   pixel ( 4 * x + 2 , 4 * y + 1 , color ) ;
   pixel ( 4 * x + 2 , 4 * y + 2 , color ) ;
}

void initgraph ( ) {
   `0 image.show`
   `10 10 160 64 0 image.rect`
}

int palette ( int n ) {
   return n < 6 ? 0 : n < 10 ? 0x0000FF : n < 12 ? 0x007FFF : n < 14 ? 0x00FFFF : 0xFFFFFF ;
}

int rnd ( ) {
   return seed = seed * 128 ^ ( seed >> 11 ) ^ seed * 16 ;
}

void scene ( ) {
   `0 image.hide`
   for ( x = 0 ; x < 40 ; x ++ ) {
      for ( y = 0 ; y < 16 ; y ++ )
         putpixel ( x , y , palette ( ( * ( p = ( char * ) ( ( int ) & buf + 40 * y + x ) ) = ( 3 * ( * ( char * ) ( ( int ) p + 40 ) + * p ) + * ( char * ) ( ( int ) p + 39 ) + * ( char * ) ( ( int ) p + 41 ) ) >> 3 ) & 15 ) ) ;
      * ( char * ) ( ( int ) p + 16 ) = rnd ( ) & 255 ;
   }
   `0 image.show`
}

void inittimer ( ) {
   `40 timer.interval`
   `use scene to timer`
}

void main ( ) {
   initgraph ( ) ;
   inittimer ( ) ;
}