"c.f" INCLUDE
: putpixel // forth
0 image.pixel // forth
; // ret
: tile // func
1 0 <l>  ! // init
BEGIN 0 <l> @ 7 <<> WHILE // for
1 8 <l>  ! // init
BEGIN 8 <l> @ 7 <<> WHILE // for
8 3 PICK * 0 <l> @ + 8 3 PICK * 8 <l> @ + 2 PICK putpixel 8 <l> <i++> DROP  REPEAT // endfor
0 <l> <i++> DROP  REPEAT // endfor
DROP DROP DROP <leave> ; // ret
: initgraph // func
0 image.show // forth
10 10 320 200 0 image.rect // forth
; // ret
1 <var> key // var
87 key  ! // init
: readkey // func
key.code key ! // forth
tib.clear // forth
; // ret
: initkeyb // forth
use readkey to key.down // forth
; // ret
1 <var> seed // var
1 <-x> seed  ! // init
: rnd // func
seed seed @ 128 * seed @ 11 >> ^ seed @ 16 * ^ <=> RET // ret
; // ret
1000 <var> snakex // var
1000 <var> snakey // var
1 <var> targetx // var
1 <var> targety // var
1 <var> length // var
1 <var> direction // var
87 direction  ! // init
: box // func
3 PICK 0 <l>  ! // init
BEGIN 0 <l> @ 4 PICK 3 PICK + <<> WHILE // for
4 PICK 8 <l>  ! // init
BEGIN 8 <l> @ 5 PICK 4 PICK + <<> WHILE // for
8 <l> @ 0 <l> @ 2 PICK 16 <enter> tile 8 <l> <i++> DROP  REPEAT // endfor
0 <l> <i++> DROP  REPEAT // endfor
DROP DROP DROP DROP DROP <leave> ; // ret
: newtarget // func
1 BEGIN WHILE // do
0 <l> 0 <=> DROP 8 <l> rnd 0x3FF & 40 2 - 25 2 - * <%> <=> DROP targetx 1 8 <l> @ 40 2 - <%> + <=> DROP targety 1 8 <l> @ 40 2 - / + <=> DROP 8 <l> 0 <=> DROP BEGIN 8 <l> @ length @ <<> WHILE // for
targetx @ snakex 8 <l> @ 8 <[]> @ <==> IF targety @ snakey 8 <l> @ 8 <[]> @ <==> <bool> ELSE 0 THEN IF // if
0 <l> 1 <=> DROP THEN // endif
8 <l> <++i> DROP  REPEAT // endfor
0 <l> @ REPEAT // while
targetx @ targety @ 0x00FF00 16 <enter> tile <leave> ; // ret
: init // func
0 0 40 25 0x0000FF 16 <enter> box 1 1 40 2 - 25 2 - 0x000000 16 <enter> box length 0 <=> DROP BEGIN length @ 6 <<> WHILE // for
snakex length @ 8 <[]> 40 1 >> <=> snakey length @ 8 <[]> 25 7 - length @ + <=> 0xFFFFFF 16 <enter> tile length <++i> DROP  REPEAT // endfor
direction key 87 <=> <=> DROP 16 <enter> newtarget ; // ret
: play // func
key @ 65 <==> IF direction @ 68 <!=> <bool> ELSE 0 THEN IF 1 ELSE key @ 68 <==> IF direction @ 65 <!=> <bool> ELSE 0 THEN IF 1 ELSE key @ 87 <==> IF direction @ 83 <!=> <bool> ELSE 0 THEN IF 1 ELSE key @ 83 <==> IF direction @ 87 <!=> <bool> ELSE 0 THEN <bool> THEN THEN THEN IF // if
direction key @ <=> DROP THEN // endif
snakex length @ 1 - 8 <[]> @ snakey length @ 1 - 8 <[]> @ 0x000000 16 <enter> tile 0 <l> length @ 1 - <=> DROP BEGIN 0 <l> @ 0 <>> WHILE // for
snakex 0 <l> @ 8 <[]> snakex 0 <l> @ 1 - 8 <[]> @ <=> DROP snakey 0 <l> @ 8 <[]> snakey 0 <l> @ 1 - 8 <[]> @ <=> DROP 0 <l> <--i> DROP  REPEAT // endfor
direction @ 65 <==> IF // if
snakex 0 8 <[]> <--i> DROP ELSE // else
direction @ 68 <==> IF // if
snakex 0 8 <[]> <++i> DROP ELSE // else
direction @ 87 <==> IF // if
snakey 0 8 <[]> <--i> DROP ELSE // else
direction @ 83 <==> IF // if
snakey 0 8 <[]> <++i> DROP THEN // endif
THEN // endif
THEN // endif
THEN // endif
snakex 0 8 <[]> @ snakey 0 8 <[]> @ 0xFFFFFF 16 <enter> tile snakex 0 8 <[]> @ 1 <<> IF 1 ELSE snakex 0 8 <[]> @ 40 1 - <>=> IF 1 ELSE snakey 0 8 <[]> @ 1 <<> IF 1 ELSE snakey 0 8 <[]> @ 25 1 - <>=> <bool> THEN THEN THEN IF // if
init THEN // endif
0 <l> 1 <=> DROP BEGIN 0 <l> @ length @ <<> WHILE // for
snakex 0 8 <[]> @ snakex 0 <l> @ 8 <[]> @ <==> IF snakey 0 8 <[]> @ snakey 0 <l> @ 8 <[]> @ <==> <bool> ELSE 0 THEN IF // if
init THEN // endif
0 <l> <++i> DROP  REPEAT // endfor
snakex 0 8 <[]> @ targetx @ <==> IF snakey 0 8 <[]> @ targety @ <==> <bool> ELSE 0 THEN IF // if
snakex length @ 8 <[]> snakex length @ 1 - 8 <[]> @ <=> DROP snakey length @ 8 <[]> snakey length @ 1 - 8 <[]> @ <=> DROP length <++i> DROP 16 <enter> newtarget THEN // endif
<leave> ; // ret
: scene // func
0 image.hide // forth
8 <enter> play 0 image.show // forth
; // ret
: inittimer // func
150 timer.interval // forth
use scene to timer // forth
; // ret
: main // func
initgraph initkeyb init inittimer ; // ret
<locals> main