int x , y , seed = - 1 ;
char buf [ 17 ] [ 40 ] ;

void pixel ( int x , int y , int color ) `0 image.pixel`

void putpixel ( int x , int y , int color ) {
   pixel ( 4 * x + 1 , 4 * y + 1 , color ) ;
   pixel ( 4 * x + 1 , 4 * y + 2 , color ) ;
   pixel ( 4 * x + 2 , 4 * y + 1 , color ) ;
   pixel ( 4 * x + 2 , 4 * y + 2 , color ) ;
}

void initgraph ( ) {
   `0 image.show`
   `10 10 160 64 0 image.rect`
}

int palette ( int n ) {
   return n < 6 ? 0 : n < 10 ? 0x0000FF : n < 12 ? 0x007FFF : n < 14 ? 0x00FFFF : 0xFFFFFF ;
}

int rnd ( ) {
   return seed = seed * 128 ^ ( seed >> 11 ) ^ seed * 16 ;
}

void scene ( ) {
   `0 image.hide`
   for ( x = 0 ; x < 40 ; x ++ ) {
      for ( y = 0 ; y < 16 ; y ++ ) {
         buf [ y ] [ x ] = ( 3 * ( buf [ y + 1 ] [ x ] + buf [ y ] [ x ] ) + buf [ y + 1 ] [ x - 1 ] + buf [ y + 1 ] [ x + 1 ] ) >> 3 ;
         putpixel ( x , y , palette ( buf [ y ] [ x ] & 15 ) ) ;
      }
      buf [ 16 ] [ x ] = rnd ( ) & 255 ;
   }
   `0 image.show`
}

void inittimer ( ) {
   `40 timer.interval`
   `use scene to timer`
}

void main ( ) {
   initgraph ( ) ;
   inittimer ( ) ;
}