void initgraph ( ) { `0 image.show` `10 10 144 192 0 image.rect` }
void pixel ( int x , int y , int color ) `0 image.pixel`
void tile ( int x , int y , int color ) {
   for ( int i = 1 ; i < 11 ; i ++ )
   for ( int j = 1 ; j < 11 ; j ++ )
      pixel ( 12 * x + i , 12 * y + j , color ) ;

   pixel ( 12 * x + 2 , 12 * y + 3 , 0xFFFFFF ) ;
   pixel ( 12 * x + 3 , 12 * y + 2 , 0xFFFFFF ) ;

   pixel ( 12 * x + 1 , 12 * y + 1 , 0 ) ;
   pixel ( 12 * x + 1 , 12 * y + 10 , 0 ) ;
   pixel ( 12 * x + 10 , 12 * y + 1 , 0 ) ;
   pixel ( 12 * x + 10 , 12 * y + 10 , 0 ) ;
}
int color = 0x0000FF ;

enum { LEFT = 0x41 , RIGHT = 0x44 , UP = 0x57 , DOWN = 0x53 } ;
int key ;
void readkey ( ) { `key.code key !` `tib.clear` }
void initkeyb ( ) `use readkey to key.down`

int seed = - 1 ;
int rnd ( ) { return seed = seed * 128 ^ ( seed >> 11 ) ^ seed * 16 ; }

int x = 4 , y = 0 , n = 0 , r = 0 , step , img ;

int bg [ 16 ] = {
   0x801 , 0x801 , 0x801 , 0x801 , 0x801 , 0x801 , 0x801 , 0x801 ,
   0x801 , 0x801 , 0x801 , 0x801 , 0x801 , 0x801 , 0x801 , 0xFFF
} ;

int im [ 28 ] = {
   0x0270 , 0x0232 , 0x0072 , 0x0262 ,
   0x2222 , 0x00F0 , 0x2222 , 0x00F0 ,
   0x0660 , 0x0660 , 0x0660 , 0x0660 ,
   0x0322 , 0x0071 , 0x0226 , 0x0470 ,
   0x0622 , 0x0170 , 0x0223 , 0x0074 ,
   0x0036 , 0x0462 , 0x0360 , 0x0231 ,
   0x0063 , 0x0264 , 0x0630 , 0x0132
} ;

int conflict ( int x , int y , int r ) {
   int i = im [ 4 * n + r ] ;
   return ( ( bg [ y     ] & ( (   i         & 0xF ) << x ) ) |
            ( bg [ y + 1 ] & ( ( ( i >>  4 ) & 0xF ) << x ) ) |
            ( bg [ y + 2 ] & ( ( ( i >>  8 ) & 0xF ) << x ) ) |
            ( bg [ y + 3 ] & ( ( ( i >> 12 ) & 0xF ) << x ) ) ) ;
}

void play ( ) {
   int i , j ;
   int x' = ( key == LEFT && x ) ? x - 1 : ( key == RIGHT ) ? x + 1 : x ;
   int r' = ( key == UP ) ? ( r + 1 ) & 3 : r ;
   if ( ! ( step = ( step - 1 ) & 7 ) ) key = DOWN ;
   int y' = ( key == DOWN ) ? y + 1 : y ;
   if ( conflict ( x' , y' , r' ) ) {
      if ( key == DOWN && conflict ( x , y' , r ) ) {
         bg [ y     ] |= (   img         & 0xF ) << x ;
         bg [ y + 1 ] |= ( ( img >>  4 ) & 0xF ) << x ;
         bg [ y + 2 ] |= ( ( img >>  8 ) & 0xF ) << x ;
         bg [ y + 3 ] |= ( ( img >> 12 ) & 0xF ) << x ;
         x = 4 ;
         y = 0 ;
         while ( ! ( ( color = ( rnd ( ) & 0xFFFFFF ) | 0x404040 ) & 0x808080 ) ) ;
         while ( ( n = rnd ( ) & 7 ) > 6 ) ;
      }
      else y = y' ;
   }
   else {
      x = x' ;
      y = y' ;
      r = r' ;
      for ( i = 14 : i ; i -- )
         if ( bg [ i ] == 0xFFF ) for ( j = i ; j > 0 ; j -- ) bg [ j ] = bg [ j - 1 ] ;
   }
   key = 0 ;
   img = im [ 4 * n + r ] ;
   for ( j = 0 ; j < 16 ; j ++ )
   for ( i = 0 ; i < 12 ; i ++ ) tile ( i , j , ( bg [ j ] >> i ) & 1 ? 0x7F7F7F : 0x3F3F3F ) ;
   for ( i = 0 ; i < 16 ; i ++ )
      if ( ( img >> i ) & 1 ) tile ( ( i & 3 ) + x , ( i >> 2 ) + y , color ) ;
}

void scene ( ) { `0 image.hide` play ( ) ; `0 image.show` }

void inittimer ( ) { `40 timer.interval` `use scene to timer` }

void main ( ) {
   initgraph ( ) ;
   initkeyb ( ) ;
   inittimer ( ) ;
}
