"c.f" INCLUDE
: initgraph // func
0 image.show // forth
10 10 144 192 0 image.rect // forth
; // ret
: pixel // forth
0 image.pixel // forth
; // ret
: tile // func
1 0 <l>  ! // init
BEGIN 0 <l> @ 11 <<> WHILE // for
1 8 <l>  ! // init
BEGIN 8 <l> @ 11 <<> WHILE // for
12 3 PICK * 0 <l> @ + 12 3 PICK * 8 <l> @ + 2 PICK pixel 8 <l> <i++> DROP  REPEAT // endfor
0 <l> <i++> DROP  REPEAT // endfor
12 3 PICK * 2 + 12 3 PICK * 3 + 0xFFFFFF pixel 12 3 PICK * 3 + 12 3 PICK * 2 + 0xFFFFFF pixel 12 3 PICK * 1 + 12 3 PICK * 1 + 0 pixel 12 3 PICK * 1 + 12 3 PICK * 10 + 0 pixel 12 3 PICK * 10 + 12 3 PICK * 1 + 0 pixel 12 3 PICK * 10 + 12 3 PICK * 10 + 0 pixel DROP DROP DROP <leave> ; // ret
1 <var> color // var
0x0000FF color  ! // init
1 <var> key // var
: readkey // func
key.code key ! // forth
tib.clear // forth
; // ret
: initkeyb // forth
use readkey to key.down // forth
; // ret
1 <var> seed // var
1 <-x> seed  ! // init
: rnd // func
seed seed @ 128 * seed @ 11 >> ^ seed @ 16 * ^ <=> RET // ret
; // ret
1 <var> x // var
4 x  ! // init
1 <var> y // var
0 y  ! // init
1 <var> n // var
0 n  ! // init
1 <var> r // var
0 r  ! // init
1 <var> step // var
1 <var> img // var
16 <var> bg // var
0x801 bg  ! // init
0x801 bg 8 + ! // init
0x801 bg 16 + ! // init
0x801 bg 24 + ! // init
0x801 bg 32 + ! // init
0x801 bg 40 + ! // init
0x801 bg 48 + ! // init
0x801 bg 56 + ! // init
0x801 bg 64 + ! // init
0x801 bg 72 + ! // init
0x801 bg 80 + ! // init
0x801 bg 88 + ! // init
0x801 bg 96 + ! // init
0x801 bg 104 + ! // init
0x801 bg 112 + ! // init
0xFFF bg 120 + ! // init
28 <var> im // var
0x0270 im  ! // init
0x0232 im 8 + ! // init
0x0072 im 16 + ! // init
0x0262 im 24 + ! // init
0x2222 im 32 + ! // init
0x00F0 im 40 + ! // init
0x2222 im 48 + ! // init
0x00F0 im 56 + ! // init
0x0660 im 64 + ! // init
0x0660 im 72 + ! // init
0x0660 im 80 + ! // init
0x0660 im 88 + ! // init
0x0322 im 96 + ! // init
0x0071 im 104 + ! // init
0x0226 im 112 + ! // init
0x0470 im 120 + ! // init
0x0622 im 128 + ! // init
0x0170 im 136 + ! // init
0x0223 im 144 + ! // init
0x0074 im 152 + ! // init
0x0036 im 160 + ! // init
0x0462 im 168 + ! // init
0x0360 im 176 + ! // init
0x0231 im 184 + ! // init
0x0063 im 192 + ! // init
0x0264 im 200 + ! // init
0x0630 im 208 + ! // init
0x0132 im 216 + ! // init
: conflict // func
im 4 n @ * 2 PICK + 8 <[]> @ 0 <l>  ! // init
bg 2 PICK 8 <[]> @ 0 <l> @ 0xF & 4 PICK << & bg 3 PICK 1 + 8 <[]> @ 0 <l> @ 4 >> 0xF & 5 PICK << & | bg 3 PICK 2 + 8 <[]> @ 0 <l> @ 8 >> 0xF & 5 PICK << & | bg 3 PICK 3 + 8 <[]> @ 0 <l> @ 12 >> 0xF & 5 PICK << & | NIP NIP NIP <leave> RET // ret
; // ret
: play // func
key @ 65 <==> IF x @ <bool> ELSE 0 THEN IF x @ 1 - ELSE key @ 68 <==> IF x @ 1 + ELSE x @ THEN THEN 16 <l>  ! // init
key @ 87 <==> IF r @ 1 + 3 & ELSE r @ THEN 24 <l>  ! // init
step step @ 1 - 7 & <=> <!x> IF // if
key 83 <=> DROP THEN // endif
key @ 83 <==> IF y @ 1 + ELSE y @ THEN 32 <l>  ! // init
16 <l> @ 32 <l> @ 24 <l> @ 8 <enter> conflict IF // if
key @ 83 <==> IF x @ 32 <l> @ r @ 8 <enter> conflict <bool> ELSE 0 THEN IF // if
bg y @ 8 <[]> img @ 0xF & x @ << <|=> DROP bg y @ 1 + 8 <[]> img @ 4 >> 0xF & x @ << <|=> DROP bg y @ 2 + 8 <[]> img @ 8 >> 0xF & x @ << <|=> DROP bg y @ 3 + 8 <[]> img @ 12 >> 0xF & x @ << <|=> DROP x 4 <=> DROP y 0 <=> DROP BEGIN color rnd 0xFFFFFF & 0x404040 | <=> 0x808080 & <!x> WHILE // while
REPEAT // endwhile
BEGIN n rnd 7 & <=> 6 <>> WHILE // while
REPEAT // endwhile
ELSE // else
y 32 <l> @ <=> DROP THEN // endif
ELSE // else
x 16 <l> @ <=> DROP y 32 <l> @ <=> DROP r 24 <l> @ <=> DROP 0 <l> 14 <=> DROP BEGIN 0 <l> @ WHILE // for
bg 0 <l> @ 8 <[]> @ 0xFFF <==> IF // if
8 <l> 0 <l> @ <=> DROP BEGIN 8 <l> @ 0 <>> WHILE // for
bg 8 <l> @ 8 <[]> bg 8 <l> @ 1 - 8 <[]> @ <=> DROP 8 <l> <i--> DROP  REPEAT // endfor
THEN // endif
0 <l> <i--> DROP  REPEAT // endfor
THEN // endif
key 0 <=> DROP img im 4 n @ * r @ + 8 <[]> @ <=> DROP 8 <l> 0 <=> DROP BEGIN 8 <l> @ 16 <<> WHILE // for
0 <l> 0 <=> DROP BEGIN 0 <l> @ 12 <<> WHILE // for
0 <l> @ 8 <l> @ bg 8 <l> @ 8 <[]> @ 0 <l> @ >> 1 & IF 0x7F7F7F ELSE 0x3F3F3F THEN 16 <enter> tile 0 <l> <i++> DROP  REPEAT // endfor
8 <l> <i++> DROP  REPEAT // endfor
0 <l> 0 <=> DROP BEGIN 0 <l> @ 16 <<> WHILE // for
img @ 0 <l> @ >> 1 & IF // if
0 <l> @ 3 & x @ + 0 <l> @ 2 >> y @ + color @ 16 <enter> tile THEN // endif
0 <l> <i++> DROP  REPEAT // endfor
<leave> ; // ret
: scene // func
0 image.hide // forth
40 <enter> play 0 image.show // forth
; // ret
: inittimer // func
40 timer.interval // forth
use scene to timer // forth
; // ret
: main // func
initgraph initkeyb inittimer ; // ret
<locals> main